/* avagl: parameters.cc
 * 
 * Copyright 2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#include "parameters.hh"
#include <cstdlib>

Parameters::Parameters(int gc, char *gv[], char *vp[])
{
	for (int i = 1; i < gc; i ++) {
		std::string s = gv[i];
		if (s.substr(0, 2) == "--") {
			int t = s.find("=");
			if (t > 0) opt[s.substr(2, t - 2)] = s.substr(t + 1);
			else opt[s.substr(2)] = "";
		} else {
			int t = s.find("=");
			if (t > 0) opt[s.substr(0, t)] = s.substr(t + 1);
			else opt[s] = "";
		}
	}
}

bool Parameters::exist(const std::string &name) const
{
	return opt.find(name) != opt.end();
}

double Parameters::get_double(const std::string &name) const
{
	return std::atof(opt.find(name)->second.c_str());
}

int Parameters::get_int(const std::string &name) const
{
	return std::atoi(opt.find(name)->second.c_str());
}

const std::string & Parameters::get_string(const std::string &name) const
{
	return opt.find(name)->second;
}
