/* avagl: rand48.cc
 * 
 * Copyright 2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#include "random.hh"
#include <cstdlib>

Random R;

Random::Random()
{
	init();
}

double Random::operator()()
{
	return drand48();
}

void Random::init() {
	srand48(0xaaaaaaaalu);
}

void Random::save(std::ostream &f)
{
	unsigned short sd[3];
	unsigned short *sp;

	sp = seed48(sd);
	sd[0] = sp[0];
	sd[1] = sp[1];
	sd[2] = sp[2];
	seed48(sd);
	f.write((char *) sd, 3 * sizeof(unsigned short));
}

void Random::load(std::istream &f)
{
	unsigned short sd[3];

	f.read((char *) sd, 3 * sizeof(unsigned short));
	seed48(sd);
}

