/* avagl: surface_profile.hh
 * 
 * Copyright 2003 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#include <gtk--.h>
#include <gtkgl--/glarea.h>
#include <GL/gl.h>
class SurfaceProfile
	: public Gtk::GLArea
{
private:
	GLint profile;
	double bx;
	double by;
	virtual void realize_impl();
	virtual gint motion_notify_event_impl(GdkEventMotion *);
	virtual gint button_press_event_impl(GdkEventButton *);
	virtual gint button_release_event_impl(GdkEventButton *);
	virtual gint expose_event_impl(GdkEventExpose *);
	virtual gint configure_event_impl(GdkEventConfigure *);
	GLfloat yangle;
	unsigned wid;
	unsigned len;
	double scale;
	const int * prof;
	const bool * active;
	void setupgl();
	void drawgl();
	void draw_profile();
	bool change;
public:
	SurfaceProfile(unsigned = 32, unsigned = 64, double = 0.030);
	~SurfaceProfile();
	void rotate_y(double);
	void set_profile(const int *);
	void set_active(const bool *);
	void redraw();
};
